=== os/debian/control ===
Source: openttd
Section: games
Priority: optional
Maintainer: Matthijs Kooijman <m.kooijman@student.utwente.nl>
Build-Depends: debhelper (>= 4.0.0), libsdl-dev, zlib1g-dev, libpng-dev
Standards-Version: 3.6.0

Package: openttd
Architecture: any
Depends: ${shlibs:Depends}
Suggests: timidity, freepats
Description: open source clone of the Microprose game "Transport Tycoon Deluxe"
 An enhanced open source clone of the Microprose game "Transport Tycoon Deluxe".
 You require the data files of the original Transport Tycoon Deluxe
 for Windows to play the game. You have to MANUALLY copy them to the
 game data directory! (see README.Debian for details)
